#include "HttpResponse.h"

HttpResponse::HttpResponse()
    :   mHttpVersion("1.1"),
        mStatusCode(200),
        mResponseReason("OK"),
        mContentType("text/plain"),
        mBody()
{

}

HttpResponse::~HttpResponse()
{

}

unsigned short HttpResponse::getStatusCode() const
{
    return mStatusCode;
}

const std::string& HttpResponse::getBody() const
{
    return mBody;
}

void HttpResponse::setBody(const std::string& body)
{
    mBody = body;
}

unsigned HttpResponse::getBodyLength() const
{
    return unsigned(mBody.length());
}

std::string HttpResponse::getHeaderString() const
{
    std::string header = "HTTP/" + mHttpVersion + " " + std::to_string(mStatusCode) + " " + mResponseReason + "\n";
    header += "Content-Type: " + mContentType + "\n";
    header += "Content-Length: " + std::to_string(getBodyLength()) + "\n";
    return header;
}

std::string HttpResponse::getResponseReason() const
{
    return mResponseReason;
}

std::string HttpResponse::toString() const
{
    return getHeaderString() + "\n\n" + mBody;
}
