#pragma once

#include <string>

class HttpResponse
{
public:
    HttpResponse();

    ~HttpResponse();

    void setBody(const std::string& body);

    unsigned getBodyLength() const;

    const std::string& getBody() const;

    std::string getHeaderString() const;

    std::string toString() const;

    unsigned short getStatusCode() const;

    std::string getResponseReason() const;

private:
    unsigned short mStatusCode{ 200 };
    std::string mResponseReason{ };

    std::string mHttpVersion;
    std::string mContentType;
    std::string mBody;
};
