#pragma once
#ifndef UNICODE
#define UNICODE
#endif

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif
#include <windows.h>

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0600
#endif
#include <http.h>

#include <string>

#include "Win32Buffer.h"

class HttpRequest;

class Win32WebRequest
{
public:
	Win32WebRequest();

	bool isValid() const;

	PHTTP_REQUEST getHandle() const;

	unsigned getBufferSize() const;

	void resizeBuffer(unsigned size);

	void zeroBufferMemory();

	HttpRequest getRequest() const;

private:
	std::string getUrlFromRequest() const;


	static const unsigned DEFAULT_BUFFER_SIZE{ sizeof(HTTP_REQUEST) + 2048 };
	Win32Buffer mBuffer;
	bool mIsValid{ false };

	unsigned mWorkingBufferSize{ DEFAULT_BUFFER_SIZE };
	PHTTP_REQUEST mHandle{ nullptr };
};

